<template>
  <div class="print">
    <h3>{{ course.name }}</h3>
    <div v-if="course.printFiles.nodes.length > 0">
      <h4>Custom maps:</h4>
      <div v-for="file in course.printFiles.nodes" :key="file.id">
        <a target="_blank" :href="file.url">{{ file.name }}</a>
      </div>
    </div>
    <div v-if="course.printConfig && course.printConfig.pages.length > 0">
      <div v-if="!result || result.waiting">
        <h4>Orienteer-generated map:</h4>
        <loading-dots />
        <error-view v-if="error" :error="error" />
      </div>
      <div v-else>
        <h3>Print Ready!</h3>
        <div><a :href="result.file" class="button">Download</a></div>
      </div>
    </div>
  </div>
</template>
<style lang="scss" scoped>
@import "~assets/mixins";

.print {
  @include absolute-full;
  display: flex;
  pointer-events: initial;
  background-color: $color-background;
  flex-direction: column;
  align-items: center;
  justify-content: center;

  & > div {
    max-width: 90vw;
  }
}
</style>
<script>
import { pause } from "~/lib/utils";
import { query } from "~/plugins/data-management";

const FIELDS = `fragment fields on Course { 
  id name description printConfig
  printFiles { nodes {
    id name url
  } }
}`;

const GET =
  `query($id: UUID!) {
  course : course(id: $id) { ...fields } 
}` + FIELDS;

export default {
  asyncData: async (ctx) => {
    const res = await query(GET, ({ route }) => ({ id: route.params.id }))(ctx);
    if (res.course == null) return ctx.error("404 - Course Not Found");
    return res;
  },
  data() {
    return {
      result: null,
      error: null,
      mapAt: null,
    };
  },
  async mounted() {
    if (this.$route.query.fresh == "true") {
      this.mapAt = Math.floor(new Date().getTime() / 1000);
    }

    this._going = true;
    while (!(this.result && !this.result.waiting) && !this.error) {
      await this.refresh();
      await pause(1000);
    }
  },
  beforeDestroy() {
    this.error = "destroyed";
  },
  methods: {
    async refresh() {
      const { error, result } = await this.$net({
        url:
          `/print/meta/${this.$route.params.id}` +
          (this.mapAt ? `?map_at=${this.mapAt}` : ""),
      });

      this.result = result;
      this.error = error;

      /* if (!result.waiting) {
        document.location.href = result.file;
      } */
    },
  },
};
</script>
